<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, nextTick, onBeforeUnmount, computed } from 'vue';
import LeaderLine from 'leader-line-new';
import { storeToRefs } from 'pinia';
import { usePreviewStore } from '@/stores/preview';
import type { line } from '@/types/freeform';

const store = usePreviewStore();
const { style } = storeToRefs(store);

const props = defineProps<{
    line: line,
}>();

const lineObject:any = ref();
//TODO: rework with own Line Library
const getFontFamily = computed(()=>{
    let font;
    switch(style.value.font){
        case('arial'):
            font = "Arial, sans-serif";
            break;
        case('comic-neue'):
            font = "'Comic Neue', serif";
            break;
        case('courier'):
            font = "'Courier New', Courier, monospace";
            break;
        case('times-new-roman'):
            font = "'Times New Roman', 'Times New Roman', Times, serif";
            break;
        case('georgia'):
            font = "Georgia, serif";
            break;
        case('trebuchet-ms'):
            font = "'Trebuchet MS', sans-serif";
            break;
        case('helvetica'):
            font = "Helvetica, sans-serif";
            break;
        case('verdana'):
            font = "Verdana, sans-serif";
            break;
        default:
            font = '';
            break;
    }
    return font;
});

const createLine = () => {
    setTimeout(()=>{
        if(props.line){
            const startElem = document.getElementById(props.line.start)!;
            const endElem = document.getElementById(props.line.end)!;
            const lineStyle = style.value.lineStyle;
            lineStyle.endPlug = lineStyle.endPlug=='none'?'behind':lineStyle.endPlug;
            lineStyle.size = Number(lineStyle.size);
            let line = new LeaderLine(startElem, endElem, lineStyle);

            if(style.value.lineText == "true" || style.value.lineText){
                line.middleLabel = LeaderLine.captionLabel({text: props.line.text, outlineColor: lineStyle.color, color: '#fff', fontSize:'20px', fontWeight:'bold', fontFamily: getFontFamily.value});
            }
            lineObject.value = line;
        }
    },100);
};


createLine();

onBeforeUnmount(()=>{
    lineObject.value.show('none');
    lineObject.value.remove();
    lineObject.value = null;
});

</script>
<template>
</template>